unit keyboard;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  extctrls, StdCtrls, Buttons;

{
  Panelfarbe=$80E0FF;
  PanelGedruecktfarbe=$e0ffff;

  Panelfarbe=$FFa0a0;
  PanelGedruecktfarbe=$ffdfdf;
}
type
  TFormKeyboard = class(TForm)
    LabelTitle: TLabel;
    LabelFeedback: TLabel;
    Timer1: TTimer;

    procedure PanelMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure PanelMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);

    procedure FormShow(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);

  private
    innereHoehe:Integer;
    Farbindex:char;
    FarbtabelleGedrueckt:array['A'..'Z'] of Tcolor;
    FarbtabelleNormal:array['A'..'Z'] of Tcolor;
    winkel:array[1..4] of single;

    procedure SetTitle(const Value: string);
    function GetTitle: string;
    procedure colorNormal(panel:Tpanel);
    procedure colorPressed(panel:Tpanel);
    { Private-Deklarationen }
  public
    klartextPasswort:boolean;
    { Public-Deklarationen }
    procedure buildLayout(layout:string);
    property Title:string read GetTitle write SetTitle;
    procedure setColors(index:char; Normal, gedrueckt:Tcolor);
    procedure zahlenzeichnen;
  end;


var
  FormKeyboard: TFormKeyboard;

implementation
uses kryptool;

{$R *.DFM}

{ TForm1 }

//--------------------------------------------------------------------------
procedure TFormKeyboard.buildLayout(layout: string);
(*   '|00'   Zeilentrenner, gefolgt von 2 Zeichen Einrcktiefe in 1/10 Tastenbreite
     '& '    Leertaste
     '&&'    Das & Zeichen
     '&_'    Leerraum
     '&1'.. '&9'    1/10..9/10 Leerraum
     '&A'.. '&Z'    Tasten-Farbschema

*)
const
  ystart=192+30;      //Erste Tastenreihe
  breite=54;       //Einer Taste
  hoehe=breite;
  abstand=3;       //Zwischen den Tasten
var
  i,x,y,xa,maxx:  integer;
  panel:          Tpanel;
begin
  maxx:=0;
  x:=0;
  xa:=0;
  y:=0;
  i:=1;
  panel:=nil;

  while i<= length(layout)
  do begin
    if layout[i]='|'  //Zeilentrenner, gefolgt von 2 Zeichen Einrcktiefe (in 1/10 Tastenbreite)
    then begin
      xa:=(ord(layout[i+1])-48)*breite   + ((ord(layout[i+2])-48)*breite+9) div 10;
      x:=0;
      inc(y);
      i:=i+3;
    end else begin
      if layout[i]='&' then begin //Sonderfunktion
        Inc(i);

        if layout[i]='_'
        then begin //Sonderbehandlung: Leerraum
          inc(x);
          Inc(i);
          Continue;
        end else
        if (layout[i]>'0') and (layout[i]<='9')
        then begin //Sonderbehandlung: X-Abstand (in 1/10 Tastenbreite)
          inc(xa,(ord(layout[i])-48)*breite div 10);
          Inc(i);
          Continue;
        end else
        if (layout[i]>='A') and (layout[i]<='Z')
        then begin //Sonderbehandlung: Farbtabelle
          Farbindex:=layout[i];
          Inc(i);
          Continue;
        end else
        if layout[i]=' '
        then begin
          panel:=Tpanel.create(self);
          panel.parent:=self;
          panel.visible:=false;
          panel.OnMouseDown:=PanelMouseDown;
          panel.OnMouseUp:=PanelMouseUp;
          panel.caption:=layout[i];
          panel.Tag:=ord(Farbindex);
          colorNormal(panel);
          panel.width:=breite*4;
          panel.left:=xa+x*(breite+abstand)+abstand;
          inc(x,4);
        end else
        if layout[i]='&' //Das & Zeichen selbst
        then begin
          panel:=Tpanel.create(self);
          panel.parent:=self;
          panel.visible:=false;
          panel.OnMouseDown:=PanelMouseDown;
          panel.OnMouseUp:=PanelMouseUp;
          panel.caption:='&&'; //Sonderbehandlung & (Wird sonst zu unterstrichenem Zeichen)
          panel.caption:=layout[i];
          panel.Tag:=ord(Farbindex);
          colorNormal(panel);
          panel.width:=breite;
          panel.left:=xa+x*(breite+abstand)+abstand;
          inc(x);
        end else begin //Unbekanntes Steuerzeichen ignorieren
          inc(i);
          Continue;
        end;

      end else begin //Normales Zeichen
        panel:=Tpanel.create(self);
        panel.parent:=self;
        panel.visible:=false;
        panel.OnMouseDown:=PanelMouseDown;
        panel.OnMouseUp:=PanelMouseUp;
        panel.caption:=layout[i];
        panel.caption:=layout[i];
        panel.Tag:=ord(Farbindex);
        colorNormal(panel);
        panel.width:=breite;
        panel.left:=xa+x*(breite+abstand)+abstand;
        inc(x);
      end;
      panel.font.size:=18;
      panel.height:=hoehe;
      panel.top:=ystart+y*(hoehe+abstand);
      inc(i);
      if panel.left+panel.width>maxx then maxx:=panel.left+panel.width;
      panel.visible:=true;
    end;

  end;

  innereHoehe:=(hoehe+Abstand)*(y+1) + ystart;  //Form height
  height:=innereHoehe+32;  //Form height  +32 fr Fenstertitelzeile
  width:=maxx+30;  //Form width
  labelTitle.width:=width;
end;

//--------------------------------------------------------------------------
procedure TFormKeyboard.PanelMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  colorPressed(sender as Tpanel);
  (sender as Tpanel).bevelOuter:=bvLowered;
  FormMain.myPasswd.addChar((sender as Tpanel).caption[1]);
  LabelFeedback.Caption:=LabelFeedback.Caption + chr(65+random(26));
  if 0=(length(LabelFeedback.Caption) mod 4) then LabelFeedback.Caption:=LabelFeedback.Caption +' ';
end;

//--------------------------------------------------------------------------
procedure TFormKeyboard.FormShow(Sender: TObject);
begin
  LabelFeedback.Caption:=' ';
  FormMain.myPasswd.clear;
  if BorderStyle=bsNone
  then height:=innereHoehe
  else height:=innereHoehe+32;
end;

//--------------------------------------------------------------------------
procedure TFormKeyboard.Timer1Timer(Sender: TObject);
var
  mx,my:integer;
  l:integer;
  spalte:integer;
begin
//  timer1.Enabled:=false;
  zahlenzeichnen;
  my:=130;
  l:=30;
  for Spalte:=1 to 4 do begin
    mx:=Spalte*150 - 50;
    winkel[Spalte]:=winkel[Spalte] + 3.1415*2/(50+Spalte);
    if winkel[Spalte] > 3.1415926*2 then  begin
      winkel[Spalte]:=winkel[Spalte] - 3.1415926*2;
    end;

    canvas.brush.Color:=clBtnFace;
    canvas.Pen.Color:=clBtnFace;
  //  canvas.brush.Color:=clWhite;
    canvas.ellipse(rect(mx-l-2,my-l-2,mx+l+2,my+l+2));
    canvas.Pen.Width:=3;
    canvas.Pen.Color:=clRed;
    canvas.MoveTo(mx,my);
    canvas.LineTo(mx+round(l*sin(winkel[Spalte])) ,my-round(l*cos(winkel[Spalte])));
  end;
  timer1.Interval:=40;

end;

//--------------------------------------------------------------------------
function TFormKeyboard.GetTitle: string;
begin
  result:=LabelTitle.caption;
end;
//--------------------------------------------------------------------------
procedure TFormKeyboard.SetTitle(const Value: string);
begin
  LabelTitle.caption := Value;
end;


//--------------------------------------------------------------------------
procedure TFormKeyboard.PanelMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  colorNormal(sender as Tpanel);
  (sender as Tpanel).bevelOuter:=bvRaised;
end;




//--------------------------------------------------------------------------
procedure TFormKeyboard.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if #13=key then begin
    close;
  end else begin
    klartextPasswort:=false;
    FormMain.myPasswd.addChar(Key);
    LabelFeedback.Caption:=LabelFeedback.Caption + chr(65+random(26));
    if 0=(length(LabelFeedback.Caption) mod 4) then LabelFeedback.Caption:=LabelFeedback.Caption +' ';
  end;
end;
//--------------------------------------------------------------------------
procedure TFormKeyboard.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  n:integer;
  spalte:integer;
  c:char;
begin

  spalte:=1 + (x-30) div 150;
  c:='?';
  case spalte  of
  1:begin
      n:=round(winkel[spalte] / (3.1415*2/10));
      if n>9 then n:=0;
      c:=chr(48+n);
    end;
  2:begin
      n:=round(winkel[spalte] / (3.1415*2/8));
      if n>7 then n:=0;
      c:=chr(65+n);
    end;
  3:begin
      n:=round(winkel[spalte] / (3.1415*2/9));
      if n>8 then n:=0;
      c:=chr(65+n+8);
    end;
  4:begin
      n:=round(winkel[spalte] / (3.1415*2/9));
      if n>8 then n:=0;
      c:=chr(65+n+17);
    end;
  end;
  if klartextPasswort
  then LabelFeedback.Caption:=LabelFeedback.Caption + c //Zeichen im Klartext
  else LabelFeedback.Caption:=LabelFeedback.Caption + chr(65+random(26));
  FormMain.myPasswd.addChar(c);
  if 0=(length(LabelFeedback.Caption) mod 4) then LabelFeedback.Caption:=LabelFeedback.Caption +' ';

end;

//--------------------------------------------------------------------------
procedure TFormKeyboard.setColors(index: char; Normal, gedrueckt: Tcolor);
begin
  FarbtabelleGedrueckt[index]:=gedrueckt;
  FarbtabelleNormal[index]:=normal;
end;

//--------------------------------------------------------------------------
procedure TFormKeyboard.FormCreate(Sender: TObject);
var
  c: char;
  i:integer;
begin
  klartextPasswort:=true;
  DoubleBuffered:=true;
  //Farbtabelle initialisieren
  setColors('A', $80E0FF, $e0ffff);
  setColors('B', $FFa0a0, $ffd0d0);
  setColors('C', $a0a0ff, $d0d0ff);
  setColors('D', $ffa0ff, $ffd0ff);
  for c:='E' to 'Z' do begin
    setColors(c, $a0a0a0, $ffffff);
  end;
  Farbindex:='A';
  randomize;
  for i:=1 to high(winkel)
  do winkel[i]:= 3.1415*2/10/4 * random(40);
end;


//--------------------------------------------------------------------------
procedure TFormKeyboard.colorNormal(panel: Tpanel);
begin
  panel.color:=FarbtabelleNormal[chr(panel.Tag)];
end;

//--------------------------------------------------------------------------
procedure TFormKeyboard.colorPressed(panel: Tpanel);
begin
  panel.color:=FarbtabelleGedrueckt[chr(panel.Tag)];
end;


//--------------------------------------------------------------------------
procedure TFormKeyboard.zahlenzeichnen;
const
  d=3;
  yu=60;
var
  i:integer;
  mx,my,x,y:integer;
  l:integer;
  w:single;
begin
  mx:=100;
  my:=130;

  canvas.brush.Color:=clBtnFace;
//  canvas.brush.Color:=clRed;
  x:=100;
  canvas.fillrect(rect(x-60,my-60,x+60,my+yu));
  inc(x,150);
//  canvas.brush.Color:=clBlue;
  canvas.fillrect(rect(x-60,my-60,x+60,my+yu));
  inc(x,150);
//  canvas.brush.Color:=clGreen;

  canvas.fillrect(rect(x-60,my-60,x+60,my+yu));
  inc(x,150);
//  canvas.brush.Color:=clFuchsia;
  canvas.fillrect(rect(x-60,my-60,x+60,my+yu));


  for i:=0 to 9 do begin
    w:=3.1415*2/10 * i;
    l:=35+d;
    x:=mx+round(l*sin(w));
    y:=my-round(l*cos(w));
    canvas.brush.Color:=clBlue;
    canvas.fillrect(rect(x-d,y-d,x+d,y+d));
    l:=45+d;
    x:=mx+round(l*sin(w));
    y:=my-round(l*cos(w));

    canvas.brush.Color:=clBtnFace;
    canvas.Font.Size:=8;
    canvas.Font.Color:=clRed;
    canvas.TextOut(x-3,y-7 ,intTostr(i));
  end;


  mx:=250;
  for i:=0 to 7 do begin
    w:=3.1415*2/8 * i;
    l:=35+d;
    x:=mx+round(l*sin(w));
    y:=my-round(l*cos(w));
    canvas.brush.Color:=clBlue;
    canvas.fillrect(rect(x-d,y-d,x+d,y+d));
    l:=45+d;
    x:=mx+round(l*sin(w));
    y:=my-round(l*cos(w));

    canvas.brush.Color:=clBtnFace;
    canvas.Font.Size:=8;
    canvas.Font.Color:=clRed;
    canvas.TextOut(x-3,y-7 ,chr(i+65));
  end;

  mx:=400;
  for i:=0 to 8 do begin
    w:=3.1415*2/9 * i;
    l:=35+d;
    x:=mx+round(l*sin(w));
    y:=my-round(l*cos(w));
    canvas.brush.Color:=clBlue;
    canvas.fillrect(rect(x-d,y-d,x+d,y+d));
    l:=45+d;
    x:=mx+round(l*sin(w));
    y:=my-round(l*cos(w));

    canvas.brush.Color:=clBtnFace;
    canvas.Font.Size:=8;
    canvas.Font.Color:=clRed;
    canvas.TextOut(x-3,y-7 ,chr(i+65+8));
  end;

  mx:=550;
  for i:=0 to 8 do begin
    w:=3.1415*2/9 * i;
    l:=35+d;
    x:=mx+round(l*sin(w));
    y:=my-round(l*cos(w));
    canvas.brush.Color:=clBlue;
    canvas.fillrect(rect(x-d,y-d,x+d,y+d));
    l:=45+d;
    x:=mx+round(l*sin(w));
    y:=my-round(l*cos(w));

    canvas.brush.Color:=clBtnFace;
    canvas.Font.Size:=8;
    canvas.Font.Color:=clRed;
    canvas.TextOut(x-3,y-7 ,chr(i+65+17));
  end;

end;

end.
